/***********************************************************************
 *
 * Copyright (C) 2005 by FS Forth-Systeme GmbH.
 * All rights reserved.
 *
 * $Id: debug-macro.S,v 1.2 2005/09/29 14:59:12 jdietsch Exp $
 * @Author: Jonas Dietsche
 * @References: 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 ***********************************************************************/
/***********************************************************************
 *  @History:
 *     2005/09/29: fixed bug #411
 ***********************************************************************/
 
#include <asm/arch/ns9750_ser.h>

		.macro	addruart,rx
		mrc	p15, 0, \rx, c1, c0
		tst	\rx, #1			@ MMU enabled?
		moveq	\rx, #0x90000000 @ physical base address
		addeq   \rx, \rx, #0x00200000
		movne	\rx, #0xf0000000	@ virtual base
		addne	\rx, \rx, #(0x90000000) >> 4
		addne   \rx, \rx, #(0x00200000) >> 4
		.endm

		.macro	senduart,rd,rx
		strb	\rd, [\rx, #(0x10)] @NS_SER_FIFO
		.endm

		.macro	waituart,rd,rx
1001:		ldr	\rd, [\rx, #(0x08)] @NS_SER_STAT_A
		tst	\rd, #NS_SER_STAT_A_RFULL
		bne	1001b
		.endm

		.macro	busyuart,rd,rx
		.endm
